﻿using System;
using System.Linq;
using System.Collections.Generic;
using System.Text;
using System.Runtime.InteropServices;

namespace INT_PT002.DataStore
{
    public class SystemConfiguration
    {
        #region Field
        private int m_VacuumStartTime;
        private int m_VacuumHoldTime;
        private int m_VacuumBreakTime;
        private int m_Chart1DrawStep;
        private int m_Chart2DrawStep;
       
        private string m_OverRange;
        #endregion

        #region Constructor
        public SystemConfiguration()
        {
            this.Initialize();
        }
        #endregion

        #region Property
        public int VacuumStartTime
        {
            get { return this.m_VacuumStartTime; }
            set { this.m_VacuumStartTime = value; }
        }
        public int VacuumHoldTime
        {
            get { return this.m_VacuumHoldTime; }
            set { this.m_VacuumHoldTime = value; }
        }
        public int VacuumBreakTime
        {
            get { return this.m_VacuumBreakTime; }
            set { this.m_VacuumBreakTime = value; }
        }
        public int Chart1DrawStep
        {
            get { return this.m_Chart1DrawStep; }
            set { this.m_Chart1DrawStep = value; }
        }
        public int Chart2DrawStep
        {
            get { return this.m_Chart2DrawStep; }
            set { this.m_Chart2DrawStep = value; }
        }

        public string OverRange
        {
            get { return this.m_OverRange; }
            set { this.m_OverRange = value; }
        }
        #endregion

        #region Method
        public void Initialize()
        {
            this.VacuumStartTime = 3;
            this.VacuumHoldTime = 4;
            this.VacuumBreakTime = 5;
            this.Chart1DrawStep = 4;
            this.Chart2DrawStep = 2;

            this.OverRange = "10000";
        }
        #endregion
    }

    [StructLayout(LayoutKind.Sequential)]
    public struct StructSystemConfigurationItem
    {
        public int VacuumStartTime;
        public int VacuumHoldTime;
        public int VacuumBreakTime;
        public int Chart1DrawStep;
        public int Chart2DrawStep;

        [MarshalAs(UnmanagedType.ByValTStr, SizeConst = 15)]
        public string OverRange;
    }
}
